#property copyright "Copyright  2011, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

#property indicator_chart_window
#property indicator_buffers 4

#property indicator_color1 Black
#property indicator_color2 Black
#property indicator_color3 Black
#property indicator_color4 Black

extern int pivotStrength = 5;
extern int maxLookBackBars = 200;
extern int pivotPipDiff = 10;
extern int zonePipSize = 2;
extern int maxLevels = 3;
extern bool show_black_lines = false;
bool gi_96 = TRUE;
double g_ibuf_100[];
double g_ibuf_104[];
double g_ibuf_108[];
double g_ibuf_112[];
string g_symbol_116 = "";
double g_point_124 = 0.0;
double g_digits_132 = 0.0;
int gi_140 = 1;

int init() {
   IndicatorBuffers(4);
   SetIndexBuffer(0, g_ibuf_100);
   SetIndexBuffer(1, g_ibuf_104);
   SetIndexBuffer(2, g_ibuf_108);
   SetIndexBuffer(3, g_ibuf_112);
   if (!show_black_lines) {
   SetIndexEmptyValue(0,0.0);
   SetIndexEmptyValue(1,0.0);
   SetIndexEmptyValue(2,0.0);
   SetIndexEmptyValue(3,0.0);
   }


   g_symbol_116 = Symbol();
   g_point_124 = MarketInfo(g_symbol_116, MODE_POINT);
   g_digits_132 = MarketInfo(g_symbol_116, MODE_DIGITS);
   if (g_point_124 == 0.001) {
      g_point_124 = 0.01;
      g_digits_132 = 3;
   } else {
      if (g_point_124 == 0.00001) {
         g_point_124 = 0.0001;
         g_digits_132 = 5;
      }
   }
   if (g_digits_132 == 3.0 || g_digits_132 == 5.0) gi_140 = 10;
   return (0);
}

int deinit() {
   ObjectDelete("resZone1");
   ObjectDelete("resLine1");
   ObjectDelete("resTag1");
   ObjectDelete("supZone1");
   ObjectDelete("supLine1");
   ObjectDelete("supTag1");
   ObjectDelete("resZone2");
   ObjectDelete("resLine2");
   ObjectDelete("resTag2");
   ObjectDelete("supZone2");
   ObjectDelete("supLine2");
   ObjectDelete("supTag2");
   ObjectDelete("resZone3");
   ObjectDelete("resLine3");
   ObjectDelete("resTag3");
   ObjectDelete("supZone3");
   ObjectDelete("supLine3");
   ObjectDelete("supTag3");
   return (0);
}

int start() {
   int li_28;
   double l_point_32;
   double ld_40;
   double ld_48;
   string ls_56;
   bool li_64;
   int l_ind_counted_0 = IndicatorCounted();
   int li_4 = Bars - l_ind_counted_0;
   int li_8 = 0;
   if (gi_96) li_8 = 1;
   for (int li_24 = li_4; li_24 >= li_8; li_24--) {
      li_28 = iHighest(Symbol(), 0, MODE_HIGH, pivotStrength * 2 + 1, li_24);
      g_ibuf_100[li_24] = 0;
      g_ibuf_104[li_24] = 0;
      g_ibuf_108[li_24] = 0;
      g_ibuf_112[li_24] = 0;
      if (li_28 == li_24 + pivotStrength) {
         g_ibuf_100[li_24] = High[li_28];
         g_ibuf_104[li_24] = Time[li_28];
      }
      li_28 = iLowest(Symbol(), 0, MODE_LOW, pivotStrength * 2 + 1, li_24);
      if (li_28 == li_24 + pivotStrength) {
         g_ibuf_108[li_24] = Low[li_28];
         g_ibuf_112[li_24] = Time[li_28];
      }
      if (li_24 == li_8) {
         l_point_32 = MarketInfo(Symbol(), MODE_POINT);
         ld_40 = Close[li_8];
         ld_48 = 0;
         ls_56 = "";
         li_64 = FALSE;
         for (int li_68 = 1; li_68 <= maxLevels; li_68++) {
            ld_40 = get_sr_level(ld_40, 1, li_8);
            if (ld_40 == ld_48) ls_56 = ls_56 + " L" + li_68;
            else {
               ls_56 = "L" + li_68;
               li_64 = li_68;
            }
            DrawRectangle("resZone" + li_64, ld_40 - zonePipSize * l_point_32 * gi_140 / 2.0, ld_40 + zonePipSize * l_point_32 * gi_140 / 2.0, Time[li_8], Time[li_8 + maxLookBackBars - 1], Red, 3);
            DrawHorizontalLine("resLine" + li_64, ld_40 - zonePipSize * l_point_32 * gi_140 / 2.0, Time[li_8], Time[li_8 + maxLookBackBars - 1], STYLE_SOLID, Red, 1);
            DrawLabel("resTag" + li_64, ls_56, Time[3], ld_40, Red);
            ld_48 = ld_40;
            ld_40 += pivotPipDiff * l_point_32 * gi_140;
         }
         ld_40 = Close[li_8];
         ld_48 = 0;
         ls_56 = "";
         li_64 = FALSE;
         for (li_68 = 1; li_68 <= maxLevels; li_68++) {
            ld_40 = get_sr_level(ld_40, -1, li_8);
            if (ld_40 == ld_48) ls_56 = ls_56 + " L" + li_68;
            else {
               ls_56 = "L" + li_68;
               li_64 = li_68;
            }
            DrawRectangle("supZone" + li_64, ld_40 - zonePipSize * l_point_32 * gi_140 / 2.0, ld_40 + zonePipSize * l_point_32 * gi_140 / 2.0, Time[li_8], Time[li_8 + maxLookBackBars - 1], Blue, 3);
            DrawHorizontalLine("supLine" + li_64, ld_40 - zonePipSize * l_point_32 * gi_140 / 2.0, Time[li_8], Time[li_8 + maxLookBackBars - 1], STYLE_SOLID, Blue, 1);
            DrawLabel("supTag" + li_64, ls_56, Time[3], ld_40, Blue);
            ld_48 = ld_40;
            ld_40 -= pivotPipDiff * l_point_32 * gi_140;
         }
      }
   }
   return (0);
}

double get_sr_level(double ad_0, int ai_8, int ai_12) {
   double lda_48[];
   double lda_52[];
   int l_index_16 = 0;
   int l_index_20 = 0;
   double ld_ret_24 = 0;
   int li_32 = 0;
   int li_36 = 0;
   int li_40 = -1;
   int li_44 = -1;
   ArrayResize(lda_48, maxLookBackBars);
   ArrayInitialize(lda_48, 0);
   ArrayResize(lda_52, maxLookBackBars);
   ArrayInitialize(lda_52, 0);
   l_index_16 = ai_12;
   for (l_index_20 = 0; l_index_20 < MathMin(maxLookBackBars, Bars) && l_index_16 < Bars; l_index_16++) {
      if (g_ibuf_100[l_index_16] != 0.0) {
         lda_48[l_index_20] = g_ibuf_100[l_index_16];
         lda_52[l_index_20] = g_ibuf_104[l_index_16];
         l_index_20++;
      }
      if (g_ibuf_108[l_index_16] != 0.0) {
         lda_48[l_index_20] = g_ibuf_108[l_index_16];
         lda_52[l_index_20] = g_ibuf_112[l_index_16];
         l_index_20++;
      }
   }
   double l_point_56 = MarketInfo(Symbol(), MODE_POINT);
   int l_count_64 = 0;
   int l_count_68 = 0;
   li_32 = 0;
   li_36 = 0;
   li_40 = -1;
   li_44 = -1;
   for (l_index_16 = 0; l_index_16 <= maxLookBackBars - 1; l_index_16++) {
      if (lda_52[l_index_16] < Time[maxLookBackBars]) break;
      l_count_64 = 0;
      l_count_68 = 0;
      for (l_index_20 = maxLookBackBars - 2; l_index_20 >= 0; l_index_20--) {
         if (lda_52[l_index_20] > Time[maxLookBackBars] && lda_48[l_index_20] > 0.0) {
            if (ai_8 > 0 && lda_48[l_index_16] > 0.0 && lda_48[l_index_16] >= ad_0) {
               if (MathAbs(lda_48[l_index_16] - lda_48[l_index_20]) / (l_point_56 * gi_140) <= pivotPipDiff) l_count_64++;
               if (l_count_64 > li_32) {
                  li_32 = l_count_64;
                  ld_ret_24 = lda_48[l_index_16];
                  li_40 = l_index_16;
               }
            }
            if (ai_8 < 0 && lda_48[l_index_16] > 0.0 && lda_48[l_index_16] <= ad_0) {
               if (MathAbs(lda_48[l_index_16] - lda_48[l_index_20]) / (l_point_56 * gi_140) <= pivotPipDiff) l_count_68++;
               if (l_count_68 > li_36) {
                  li_36 = l_count_68;
                  ld_ret_24 = lda_48[l_index_16];
                  li_44 = l_index_16;
               }
            }
         }
      }
   }
   if (ai_8 > 0) {
      if (li_40 >= 0) ld_ret_24 = lda_48[li_40];
      else ld_ret_24 = High[iHighest(Symbol(), 0, MODE_HIGH, maxLookBackBars, ai_12)];
   }
   if (ai_8 < 0) {
      if (li_44 >= 0) ld_ret_24 = lda_48[li_44];
      else ld_ret_24 = Low[iLowest(Symbol(), 0, MODE_LOW, maxLookBackBars, ai_12)];
   }
   return (ld_ret_24);
}

void DrawHorizontalLine(string a_name_0, double ad_8, int a_datetime_16, int a_datetime_20, int a_style_24, double a_color_28, int a_width_36) {
   if (ObjectFind(a_name_0) == -1) ObjectCreate(a_name_0, OBJ_TREND, 0, 0, 0);
   ObjectSet(a_name_0, OBJPROP_BACK, FALSE);
   ObjectSet(a_name_0, OBJPROP_PRICE1, ad_8);
   ObjectSet(a_name_0, OBJPROP_PRICE2, ad_8);
   ObjectSet(a_name_0, OBJPROP_COLOR, a_color_28);
   ObjectSet(a_name_0, OBJPROP_STYLE, a_style_24);
   ObjectSet(a_name_0, OBJPROP_WIDTH, a_width_36);
   ObjectSet(a_name_0, OBJPROP_TIME1, a_datetime_16);
   ObjectSet(a_name_0, OBJPROP_TIME2, a_datetime_20);
   ObjectSet(a_name_0, OBJPROP_RAY, FALSE);
}

void DrawLabel(string a_name_0, string a_text_8, int a_datetime_16, double a_price_20, color a_color_28) {
   if (ObjectFind(a_name_0) != 0) ObjectCreate(a_name_0, OBJ_TEXT, 0, a_datetime_16, a_price_20);
   else ObjectMove(a_name_0, 0, a_datetime_16, a_price_20);
   ObjectSetText(a_name_0, a_text_8, 8, "Arial", a_color_28);
}

void DrawRectangle(string a_name_0, double ad_8, double ad_16, int a_datetime_24, int a_datetime_28, double a_color_32, int a_width_40) {
   if (ObjectFind(a_name_0) == -1) ObjectCreate(a_name_0, OBJ_RECTANGLE, 0, 0, 0, 0, 0);
   ObjectSet(a_name_0, OBJPROP_TIME1, a_datetime_24);
   ObjectSet(a_name_0, OBJPROP_TIME2, a_datetime_28);
   ObjectSet(a_name_0, OBJPROP_COLOR, a_color_32);
   ObjectSet(a_name_0, OBJPROP_PRICE1, ad_8);
   ObjectSet(a_name_0, OBJPROP_PRICE2, ad_16);
   ObjectSet(a_name_0, OBJPROP_STYLE, STYLE_SOLID);
   ObjectSet(a_name_0, OBJPROP_WIDTH, a_width_40);
   ObjectSet(a_name_0, OBJPROP_BACK, TRUE);
}